/// SyModuleVST.h
///
/// (c) 2010 Bastian Spiegel <bs@tkscript.de>
///     - Distributed under terms of the Lesser GNU General Public License (LGPL).
///       See COPYING and <http://www.gnu.org/licenses/licenses.html#LGPL> for further information.
///
///
/// created: 06Oct2010
/// changed: 07Oct2010, 10Oct2010, 11Oct2010, 16Oct2010
///
///
///

#ifndef __SYMODULEVST_H__
#define __SYMODULEVST_H__



YG("vst2");


#define SYMODULEVST_DATATYPE_NONE         0
#define SYMODULEVST_DATATYPE_BANKCHUNK    1
#define SYMODULEVST_DATATYPE_PROGRAMCHUNK 2
#define SYMODULEVST_DATATYPE_PARAMETERS   3


YC class SyModuleVST : public SyModule {

   // (note) VST modules only have audio I/O ports
   //        parameters 

  protected:
   VST2Plugin *plugin; // (deletable) reference to plugin instance

   sUI ui_vstgenerator_id; // written to when a song is saved

   sSI         patch_data_type; // SYMODULEVST_DATATYPE_xxx
   YAC_Buffer *patch_data;      // allocated by queryPatchData()



  public:
   YAC_POOLED(SyModuleVST, YAC_POOL_PRIORITY_LOW);
   /* /\* YAC(SyModuleVST); *\/ */

   SyModuleVST(void);
   ~SyModuleVST();

   // (note) the init method is not re-implemented in this class (SyModule::init() is called), please call initVST instead
   YM sBool initVST  (YAC_String *_pathName, sF32 _rate, sUI _maxFrames);

   YM void unloadVST(void);

   // (note) usually called by initVST. Also used to set a dummy plugin to prevent crashes
   YM void allocPlugin (void);

   void reset       (void);
   void doCalc      (sUI _framesAdvance);
   void doCalcBlock (sUI _numFrames);

   /* /\* sUI getNumInputs  (void); // overwrites SyModule::getNumInputs *\/ */
   /* /\* sUI getNumOutputs (void); // overwrites SyModule::getNumOutputs *\/ */

   YM YAC_Object *getPlugin (void);

   YM void uiSetVSTGeneratorId (sUI _id);
   YM sUI  uiGetVSTGeneratorId (void);

   sBool saveStream (YAC_Object *_ofs);
   sBool readStream (YAC_Object *_ifs);

   YM sBool queryPatchData   (void);
   YM sBool restorePatchData (void);

};


#endif // __SYMODULEVST_H__
